<!--
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../polymer/polymer.html">

<!--
`<hook-material-card>` is a card element that displays a full size image on one side or end of the card (`<img>`, `<iron-image>`, `<video>`), and some text/copy on the other.  The 'vertical' attribute displays the content in a stacked layout. The 'layout-reverse' attribute will reverse the order of what goes on the left/top and what goes on the right/bottom (desktop).  Mobile layout stacks with the hero image displayed first (top).

Example:

    <hook-material-card>

      <iron-image sizing="cover" preload src="../path/to/image.jpg" card-hero></iron-image>

      <div card-content>
        <h1>Your title</h1>
        <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. 
        Omnis, nostrum rerum sunt, cum ipsum dolorem, laudantium 
        culpa reiciendis aliquid delectus eaque. Quisquam quia, 
        impedit ab. Quidem illum vitae iure velit!</p>
      </div>
    </hook-material-card>

### Styling

The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--card-hero-flex-value` | flex property: flex value | 2
`--card-hero-padding` | padding value for hero section of card | 0
`--card-content-flex-value` | flex property: flex value | 1
`--card-content-padding` | padding value for content section of card | 25px
`--card-content-text-align` | content section text align property value | left
`--card-background-color` | card background color | white
`--card-border` | box shadow values - set to 'none' to remove | present

@element hook-material-card
@demo demo/index.html
-->

<dom-module id="hook-material-card">
  <template>
    <style>
      :host {
        --card-hero-flex-value: 2;
        --card-hero-padding: 0;
        --card-content-flex-value: 1;
        --card-content-padding: 25px;
        --card-content-text-align: left;
        --card-background-color: #ffffff;     
        --card-border: 0 3px 6px rgba(0,0,0,0.16), 0 3px 6px rgba(0,0,0,0.23);
        
        display: block;
      }

      .card-layout {
        display: -webkit-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        -webkit-flex-direction: row;
            -ms-flex-direction: row;
                flex-direction: row;
        -ms-flex-align: center;
        -webkit-align-items: center;
                align-items: center;
        background: var(--card-background-color);
        -webkit-box-shadow: var(--card-border);
                box-shadow: var(--card-border);
      }

      /**
       * Hero Styles
       */
      #hero {
        position: relative;
        overflow: hidden;
        width: 100%;
        padding: var(--card-hero-padding);
        -webkit-flex: var(--card-hero-flex-value);
            -ms-flex: var(--card-hero-flex-value);
                flex: var(--card-hero-flex-value);
      }

      #hero ::content img {
        display: block;
        width: 100%;
        max-width: 100%;
        height: auto;
      }

      /**
       * Content styles
       */
      #content {
        width: 100%;
        padding: var(--card-content-padding);
        display: -webkit-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        -webkit-flex-direction: column;
            -ms-flex-direction: column;
                flex-direction: column;
        -webkit-flex: var(--card-content-flex-value);
            -ms-flex: var(--card-content-flex-value);
                flex: var(--card-content-flex-value);
        text-align: var(--card-content-text-align);
        -webkit-box-sizing: border-box;
           -moz-box-sizing: border-box;
                box-sizing: border-box;
      }

      :host([vertical]) .card-layout {
        -webkit-flex-direction: column;
            -ms-flex-direction: column;
                flex-direction: column;
      }

      :host([row-reverse]) .card-layout {
        -webkit-flex-direction: row-reverse;
            -ms-flex-direction: row-reverse;
                flex-direction: row-reverse;
      }

      :host([column-reverse]) .card-layout {
        -webkit-flex-direction: column-reverse;
            -ms-flex-direction: column-reverse;
                flex-direction: column-reverse;
      }

      :host([hero-only]) .card-layout #content {
        display: none;
      }

      @media screen and (max-width: 767px) {
        .card-layout,
        :host([row-reverse]) .card-layout,
        :host([column-reverse]) .card-layout {
          -webkit-flex-direction: column;
              -ms-flex-direction: column;
                  flex-direction: column;
        }
      }

    </style>

    <div class="card-layout">
      <!-- hero -->
      <div id="hero">

        <content select="[card-hero]"></content>

      </div>

      <!-- content -->
      <div id="content">

        <content select="[card-content]"></content>

      </div>
    </div>


  </template>

  <script>
    Polymer({

      is: 'hook-material-card'

    });
  </script>
</dom-module>
